Loading...
Searching...
No Matches
PointTreeMarcher< AccT, RayT, CoordT > Class Template Reference

A Tree Marcher for Point Grids. More...

`#include <nanovdb/util/HDDA.h>`

Inheritance diagram for PointTreeMarcher< AccT, RayT, CoordT >:

## Public Types

using | ChildT
using | RealType
using | RealT
using | CoordType

## Public Member Functions

__hostdev__ | PointTreeMarcher (AccT &acc)
__hostdev__ bool | init (RayT ray)
| Initiates this instance with a ray in index space.
__hostdev__ bool | init (const RayT &indexRay)
| Initialize the TreeMarcher with an index-space ray.
__hostdev__ bool | step (const LeafNode< AccT::ValueType > **node, float &t0, float &t1)
| step the ray through the tree. If the ray hits a node then populate t0 & t1, and the node.
__hostdev__ const RayT & | ray () const

## Detailed Description

template<typename AccT, typename RayT, typename CoordT = Coord>
class nanovdb::PointTreeMarcher< AccT, RayT, CoordT >

A Tree Marcher for Point Grids.

Note
  This class will handle correctly offseting the ray by 0.5 to ensure that the underlying HDDA will intersect with the grid-cells. See details below.

## Member Typedef Documentation

## ChildT

using ChildT

inherited

## CoordType

using CoordType

inherited

## RealT

using RealT

inherited

## RealType

using RealType

inherited

## Constructor & Destructor Documentation

## PointTreeMarcher()

template<typename AccT, typename RayT, typename CoordT = Coord>

__hostdev__ PointTreeMarcher | ( | AccT & | acc | ) |

inline

## Member Function Documentation

## init() [1/2]

template<typename AccT, typename RayT, typename CoordT = Coord>

__hostdev__ bool init | ( | RayT | ray | ) |

inline

Initiates this instance with a ray in index space.

An offset by 0.5 is applied to the ray to account for the fact that points in vdb grids are bucketed into so-called grid cell, which are centered round grid voxels, whereas the DDA is based on so-called grid nodes, which are coincident with grid voxels. So, rather than offsettting the points by 0.5 to bring them into a grid node representation this method offsets the eye of the ray by 0.5, which effectively ensures that the DDA operates on grid cells as oppose to grid nodes. This subtle but important offset by 0.5 is explined in more details in our online documentation.

## init() [2/2]

__hostdev__ bool init | ( | const RayT & | indexRay | ) |

inline inherited

Initialize the TreeMarcher with an index-space ray.

## ray()

__hostdev__ const RayT & ray | ( |  | ) | const

inline inherited

## step()

__hostdev__ bool step | ( | const LeafNode< AccT::ValueType > ** | node,
|  | float & | t0,
|  | float & | t1 )

inline inherited

step the ray through the tree. If the ray hits a node then populate t0 & t1, and the node.

Returns
  true when a node of type NodeT is intersected, false otherwise.